import React, { useState } from "react";

interface Widget {
  id: string;
  name: string;
}

const WidgetsFloating = () => {
  const [widgets, setWidgets] = useState<Widget[]>([
    { id: "1", name: "Working State Widget" },
    { id: "2", name: "Floating Widget 2" },
    { id: "3", name: "Floating Widget 3" },
    { id: "4", name: "Floating Widget 4" },
  ]);
  
  console.log('setWidgets: ', setWidgets);
  // Function to handle drag start
  const handleDragStart = (
    e: React.DragEvent<HTMLDivElement>,
    widget: Widget
  ) => {
    e.dataTransfer.setData("application/json", JSON.stringify(widget));
  };

  return (
    <div className="floatingWidgets-wrapper">
      {widgets.map((widget) => (
        <div
          key={widget.id}
          className="floating"
          draggable
          onDragStart={(e) => handleDragStart(e, widget)}
        >
          {widget.name}
        </div>
      ))}
    </div>
  );
};

export default WidgetsFloating;
