// import { create } from "zustand";

// type Side = "top" | "bottom" | "left" | "right";

// interface Widget {
//   id: string;
//   type: string;
//   title: string;
//   panel: Side;
//   data: any;
// }

// interface SelectedZoneState {
//   zoneName: string;
//   activeSides: Side[];
//   panelOrder: Side[];
//   lockedPanels: Side[];
//   widgets: Widget[];
// }

// interface SelectedZoneStore {
//   selectedZone: SelectedZoneState;
//   setSelectedZone: (zone: Partial<SelectedZoneState> | ((prev: SelectedZoneState) => SelectedZoneState)) => void;
// }

// export const useSelectedZoneStore = create<SelectedZoneStore>((set) => ({
//   selectedZone: {
//     zoneName: "Manufacturing unit",
//     activeSides: [],
//     panelOrder: [],
//     lockedPanels: [],
//     widgets: [],
//   },
//   setSelectedZone: (zone) =>
//     set((state) => ({
//       selectedZone:
//         typeof zone === "function"
//           ? zone(state.selectedZone) // Handle functional updates
//           : { ...state.selectedZone, ...zone }, // Handle partial updates
//     })),
// }));


// import { create } from "zustand";

// type Side = "top" | "bottom" | "left" | "right";

// interface Widget {
//   id: string;
//   type: string;
//   title: string;
//   panel: Side;
//   data: any;
// }

// interface SelectedZoneState {
//   zoneId: string;
//   zoneName: string;
//   activeSides: Side[];
//   panelOrder: Side[];
//   lockedPanels: Side[];
//   widgets: Widget[];
// }

// interface SelectedZoneStore {
//   selectedZone: SelectedZoneState;
//   setSelectedZone: (zone: Partial<SelectedZoneState> | ((prev: SelectedZoneState) => SelectedZoneState)) => void;
// }

// export const useSelectedZoneStore = create<SelectedZoneStore>((set) => ({
//   selectedZone: {
//     zoneId:"",
//     zoneName: "",
//     activeSides: [],
//     panelOrder: [],
//     lockedPanels: [],
//     widgets: [],
//   },
//   setSelectedZone: (zone) =>
//     set((state) => {
//       const newState =
//         typeof zone === "function"
//           ? zone(state.selectedZone) // Handle functional updates
//           : { ...state.selectedZone, ...zone }; // Handle partial updates

//       console.log("Previous state:", state.selectedZone);
//       console.log("Updated state:", newState);

//       return { selectedZone: newState };
//     }),
// }));


import { create } from "zustand";
import { io } from "socket.io-client";

const socket = io("http://192.168.0.192:4000");

type Side = "top" | "bottom" | "left" | "right";

interface Widget {
  id: string;
  type: string;
  title: string;
  panel: Side;
  data: any;
}

interface SelectedZoneState {
  zoneId: string;
  zoneName: string;
  activeSides: Side[];
  panelOrder: Side[];
  lockedPanels: Side[];
  widgets: Widget[];
}

interface SelectedZoneStore {
  selectedZone: SelectedZoneState;
  setSelectedZone: (zone: Partial<SelectedZoneState> | ((prev: SelectedZoneState) => SelectedZoneState)) => void;
}

export const useSelectedZoneStore = create<SelectedZoneStore>((set) => ({
  selectedZone: {
    zoneId: "",
    zoneName: "",
    activeSides: [],
    panelOrder: [],
    lockedPanels: [],
    widgets: [],
  },
  setSelectedZone: (zone) =>
    set((state) => {
      const newState =
        typeof zone === "function"
          ? zone(state.selectedZone)
          : { ...state.selectedZone, ...zone };

      console.log("Previous state:", state.selectedZone);
      console.log("Updated state:", newState);

      // Send updates to the backend
      socket.emit("updateZone", newState);

      return { selectedZone: newState };
    }),
}));

// Listen for backend updates
// socket.on("zoneUpdated", (updatedZone: SelectedZoneState) => {
//   console.log("Received update from server:", updatedZone);
//   useSelectedZoneStore.setState({ selectedZone: updatedZone });
// });

